package cn.zlg.www.list;

import java.util.ArrayList;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;
import cn.zlg.www.demo.R;
import cn.zlg.www.main.ItemData;
import cn.zlg.www.main.TimeGetter;
import cn.zlg.www.view.*;

public class FrmListViewAdapter extends BaseAdapter {

	public static final int MODE_FLOW = 0;
	public static final int MODE_SORT = 1;

	private LayoutInflater mLayoutInflater;
	private ArrayList<ItemData> mList;

	public FrmListViewAdapter(int nMode) {
		mList = new ArrayList<ItemData>();
	}

	@Override
	public int getCount() {
		// TODO Auto-generated method stub
		return mList.size();
	}

	@Override
	public Object getItem(int arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public long getItemId(int arg0) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public View getView(int nPos, View convertview, ViewGroup parent) {
		// TODO Auto-generated method stub
		FrmItemView itemView;
		if (convertview == null) {
			itemView = new FrmItemView();
			convertview = mLayoutInflater.inflate(R.layout.frm_item, null);
			itemView.textViewIndex = (TextView) convertview
					.findViewById(R.id.itemIndex);
			itemView.textViewID = (TextView) convertview
					.findViewById(R.id.itemID);
			itemView.textViewType = (TextView) convertview
					.findViewById(R.id.itemType);
			itemView.textViewTime = (TextView) convertview
					.findViewById(R.id.itemTime);
			itemView.textViewData = (TextView) convertview
					.findViewById(R.id.itemData);
			convertview.setTag(itemView);
		} else {
			itemView = (FrmItemView) convertview.getTag();
		}
		ItemData itemData = mList.get(nPos);
		int pos = nPos + 1;
		itemView.textViewIndex.setText("" + pos);
		itemView.textViewID.setText(String.format("0x%08X", itemData.nID));
		String string = itemData.bExtend ? "չ" : "׼";
		string += itemData.bRemote ? "Զ֡" : "֡";
		itemView.textViewType.setText(string);

		itemView.textViewTime.setText(TimeGetter.getTimeString(itemData.nTime));
		if (!itemData.bRemote) {
			int nLen = itemData.nDataLen;
			string = "";
			for (int i = 0; i < nLen; i++) {
				string += String.format("%02x ", itemData.datas[i]);
			}
			itemView.textViewData.setText(string);
		} else {
			itemView.textViewData.setText("");
		}
		if (!itemData.bRecv) {
			convertview.setBackgroundResource(R.color.antiquewhite);
		} else {
			convertview.setBackgroundResource(R.color.white);
		}

		return convertview;
	}

	public synchronized void add(ItemData itemData) {
		mList.add(itemData);
	}

	public void setLayoutInflater(LayoutInflater layoutInflater) {
		this.mLayoutInflater = layoutInflater;
	}

	public void clear() {
		mList.clear();
	}

	public ArrayList<ItemData> getList() {
		return mList;
	}
}
